//
//
//  Document.h
//
//      AUTHOR: Russell Lowke
//
//          Date: 3/26/2004
//
 
#ifndef DOCUMENT_H
#define DOCUMENT_H

#include <iostream>
#include <vector>
#include <string>
#include <fstream>
using std::ifstream;

using namespace std;

typedef vector<int>       IntList;
typedef vector<string>    StringList;


class Document {

    public:
    
        void printDocument();
        void flowDocument();
        
        // the key recursive function
        int calculatePenalty(int startIndex);
        
        Document (string filename, int lineLength);
        
        // gotta clean up after myself
        ~Document() {
            if (_knownMinPenalty)
                delete[] _knownMinPenalty;
            if (_breaks)
                delete[] _breaks;
        }
    
    private:
    
        int          _documentPenalty;
        int          _lineLength;
        IntList      _goodBreaks;                 // error flag exists to give up
                                                  // the capability to bail out if
                                                  // things mess up during initialization
        bool         _error;
        string       _filename;                   // to store the indices that we're using
                                                  // for breaks;
        IntList*     _breaks;                     // text of the file, as a vector of strings
        StringList   _text;                       // will store the minimum penalty we know
                                                  // to exist if we flow the document from 
                                                  // that point on
        int*         _knownMinPenalty;
        const static int UNKNOWN = -1;
        
};

#endif /* DOCUMENT_H */