///////////
//
//  edge.hpp
//              header for Edge.cpp package
//
//      AUTHOR: Russell James Lowke  (lowke@fas.harvard.edu)
//
//		  Date: 3/11/2004
//

#ifndef _Edge_
#define _Edge_

class Vertex;

class Edge {
 
	public:
	  bool operator< (Edge& other) {return edgeWeight < other.edgeWeight;}
	  // methods
	  Edge();
	  Edge(Vertex* mStart, double mWeight, Vertex* mEnd);	// constructor
	  void		pprint();									// print this object				
	  double	getEdgeWeight();							// return edge weight
	  Vertex*	getStart();									// start Vertex
	  Vertex*	getEnd();									// end Vertex
	  
	private:
        
	  double	edgeWeight;
	  Vertex*	startVertex;
	  Vertex*	endVertex;
};

#endif /* _Edge_ */