///////////
//
//  Vertex.hpp
//              header for vertex.cpp package
//
//      AUTHOR: Russell James Lowke  (lowke@fas.harvard.edu)
//
//		  Date: 3/11/2004
//

#ifndef _Vertex_
#define _Vertex_

class Vertex {
	  
	public:
        
	  // methods
	  Vertex();
	  Vertex(int mName, double mX, double mY);	// constructor
      ~Vertex();								// destructor, for testing purposes
	  void 		pprint();						// print this object
	  int		getName();						// return name of Vertex
	  double	getX();							// return X location
	  double	getY();							// return Y location
	  // sets stuff
	  Vertex*	getParent();						// pointer to set this Vertex is in
	  int		getRank();						// rank of this set
	  void 		setMySet(Vertex* mV);			// set pointer Vertex is in
	  void		setRank(int mRank);				// set rank of this
	  
	private:
        
	  int		name;							// each vertex is numbered
	  double	locX;							// X location of vertex
	  double 	locY;							// Y location of vertex
 
	  // pertaining to sets
 	  Vertex*	parent;							// pointer to set root
	  int		rank;							// rsnk of this set
};

#endif /* _Vertex_ */
