//
//
//  Matrix.h
//
//      AUTHOR: Russell Lowke
//
//          Date: 4/15/2004
//
 
#ifndef MATRIX_H
#define MATRIX_H

#include <vector>
using namespace std;

class Matrix;

typedef vector<int>     IntList;
typedef vector<IntList> IntLList;
typedef vector<Matrix>  MatrixList;

class Matrix {

    public:
        
        Matrix operator+ ( const Matrix& other) const ;
        Matrix operator- ( const Matrix& other) const ;
        Matrix operator* ( const Matrix& other) const ;
        
        Matrix() {};	// constructor
        Matrix(int width, int height, int data[]);
        Matrix(IntLList data);
        Matrix(Matrix a, Matrix b, Matrix c, Matrix d, int dim);
       ~Matrix() {};	// destructor
        
        void print() const;
		void printDiag() const;
		
        MatrixList makeQuarters();
        void addPadding();
        void removePadding();
        
         
        //  accessors and mutators
        void setAt(int x, int y, int val);
        int  getWidth();
        int  getHeight();
        int  getAt(int x, int y);
    
    private:
    
        int			_Width;
        int			_Height;
        IntLList	_Data;
};


#endif /* DOCUMENT_H */