//
//
//  Matrix.cpp
//
//      AUTHOR: Russell Lowke
//
//		  Date: 4/15/2004
//

#include "Matrix.h"
#include <iostream>

using namespace std;

//
//	constructor:	create a matrix of specified width and height from data[]
//
Matrix::Matrix (int width, int height, int data[]): _Width(width), _Height(height), padded(false) {
    for (int i = 0; i < (width)*(width); ++i) {
        cout << data[i] << ", ";
    }
    cout << endl;
    
    if (width % 2 != 0) {
         padded = true;
         _Data = new int[width+1 * height+1];
         
         /*
         int counterA = 0;
         int counterB = 0;
         
         for (int i = 0; i < (width+1)*(width+1); ++i){
            if ((counterA%(width+1) == width)||counterA > (width*height + 1)){
                _Data[counterA++] = 0;
            } else {
                _Data[counterA++] = data[counterB++];
            }
         }
         */
        /* 
        for (int i = 0; i < (width + 1)*(width + 1); ++i) {
            cout << _Data[i] << ", ";
        }
        cout << endl;
         */
         
        for(int y = 0; y < height +1; ++y) {
            for (int x = 0; x < width +1; ++x) {
                
                /*
                if ((x == width)||(y == height)){
                    _Data[counterA++] = 0;
                } else {
                    _Data[counterA++] = data[counterB++];
                }
                */
                if ((x == width)||(y == height)){
                    setAt(x, y, 0);
                } else {
                    setAt(x, y, data[x + (width)*y]);
                }
            }
        }
            /*

                */
       // }
    } else {
        _Data = data;
    }
}

Matrix::Matrix(int width, int height): _Width(width), _Height(height), padded(false){
    _Data = new int (_Width*_Height);
}

/*
//
//	constructor:	create matrix from four small matrices
//
Matrix::Matrix(Matrix a, Matrix b, Matrix c, Matrix d, int n): _Data(n) {

	_Width   = n;				// x
    _Height  = n;				// y
	IntLList _Data(_Width);
	
    int size = a.getWidth();    // size of small matrices
    int val;					// misc. holder
	
    // add elements
    for (int x = 0; x < _Width; ++x) {
        IntList col(_Height);					// make new column
        
        for (int y = 0; y < _Height; ++y ) {
            
            if (y <  size && x <  size)
                val = a._Data[x][y];
            else if (y <  size && x >= size)
                val = b._Data[x - size][y];
            else if (y >= size && x < size)
                val = c._Data[x][y - size];
            else if (y >= size && x >= size)
                val = d._Data[x - size][y - size];
            
            col[y] =val;
        }
        _Data[x] = col;		// add column to IntLList
    }
}
*/

//
//	constructor:	create matrix from four small matrices
//
Matrix::Matrix(Matrix a, Matrix b, Matrix c, Matrix d, int n){

	_Width   = n;				// x
    _Height  = n;				// y
        
    // add elements
    Matrix* top;
    Matrix* bottom;
    for (int x = 0; x < n; ++x) {
        //IntList col(n);					// make new column

        if (x == 0){
            top = &a;
            bottom = &c;
        } else if (x == _Width / 2) {
            top = &b;
            bottom = &d;
        }

        for (int y = 0; y < _Height; ++y ) {
            if ( x < _Width / 2){
                if ( y < _Width / 2){
                    this->setAt(x, y, top->getAt(x,y));
                } else {
                    this->setAt(x, y, bottom->getAt(x, y - n / 2));
                }
            } else {
                if ( y < _Width / 2){
                    this->setAt(x, y, top->getAt(x - n / 2, y));
                } else {
                    this->setAt(x, y, bottom->getAt(x - n / 2, y - n / 2));
                }
            }
        }
        //_Data[x] = col;					// add column to IntLList
    }
	//cout<<"Done recombining"<<endl;
}


//
// add matrices
//
Matrix Matrix::operator+ ( const Matrix& other) const {

    // IntLList mData(_Width);				// Data for resultant Matrix
    
    
    
    // ensure matrices are compatable
    if (_Width == other._Width && _Height == other._Height) {
        Matrix nMatrix(_Width, _Height);
        // add elements
        for (int x = 0; x < _Width; ++x) {
            // IntList col(_Height);		// make new column
            for (int y = 0; y < _Height; ++y ) {
                nMatrix.setAt(x, y, this->getAt(x, y) + other.getAt(x, y));
				// col[y] = _Data[x][y] + other._Data[x][y];
            }
			//mData[x] = col;				// add column to IntLList
        }
        return nMatrix;
    
    } else {
        // Matrices not compatable.
        cout << "Can't add these matrices" << endl;
        return Matrix();
    }
    
    //return Matrix(mData);
}

//
// subtract matrices
//
Matrix Matrix::operator- ( const Matrix& other) const {

    // IntLList mData(_Width);				// Data for resultant Matrix
    
    
    
    // ensure matrices are compatable
    if (_Width == other._Width && _Height == other._Height) {
        Matrix nMatrix(_Width, _Height);
        // add elements
        for (int x = 0; x < _Width; ++x) {
            // IntList col(_Height);		// make new column
            for (int y = 0; y < _Height; ++y ) {
                nMatrix.setAt(x, y, this->getAt(x, y) - other.getAt(x, y));
				// col[y] = _Data[x][y] + other._Data[x][y];
            }
			//mData[x] = col;				// add column to IntLList
        }
        return nMatrix;
    
    } else {
        // Matrices not compatable.
        cout << "Can't subtract these matrices" << endl;
        return Matrix();
    }
    
    //return Matrix(mData);
}


//
// multiply matrices
//
Matrix Matrix::operator* ( const Matrix& other) const {
    
    // Matrix will have m's height and n's width
    int height = _Height;
    int width  = other._Width;
    
	//IntLList mData(width);					// Data for resultant Matrix
	Matrix ret(width, height);
    for (int x = 0; x < width; ++x) {
        //IntList col(height);				// make new column
        for (int y = 0; y < height; ++y ) {
            int val = 0;
            for (int i = 0; i < height; ++i )
                val += (this->getAt(i, y) * other.getAt(x, i));
            ret.setAt(x, y, val);					// add column to Matrix
        }
        //mData[x] = col;
    }
    
    return ret;
}


//
//	print Matrix
//
void Matrix::print() const {
    
    for (int y = 0; y < _Height + padded; ++y) {
        cout << "[ ";
        
        for (int x = 0; x < _Width + padded; ++x) {
            cout << getAt(x, y) << " ";
        }
        
        cout << "]" << endl;
    }
    
    cout << endl;
}
    
	
//
//	print Matrix
//
void Matrix::printDiag() const {
    
	cout << "[ ";
	
    for (int y = 0; y < _Height; ++y)
        for (int x = 0; x < _Width; ++x)
			if (x == y)
				cout << this->getAt(x, y) << " ";

    cout << "]" << endl;
	
    cout << endl;
}


//
//  Partition Matrix into quarters
//			Note: Matrix assumed to be square and even [div. by 2] in size.
MatrixList Matrix::makeQuarters() {
    
    MatrixList mReturn(4);
    
    int n = _Width / 2;					// small matrix size
    
    int data[4][n * n];					// data for each new 1/4	
    int counter[] = {-1, -1, -1, -1};
    int quarter;						// quarter being used
    
    for (int y = 0; y < (_Width); ++y ) {
        for (int x = 0; x < (_Width); ++x) {

            if (x <= n-1 && y <= n-1)
                quarter = 0;			// top left
            else if (x >  n-1 && y <= n-1)
                quarter = 1;			// top right
            else if (x <= n-1 && y >  n-1)
                quarter = 2;			// bottom left
            else if (x >  n-1 && y >  n-1)
                quarter = 3;			// bottom right
            
            data[quarter][++counter[quarter]] = this->getAt(x, y);
        }
    }
    
    for (int i = 0; i < 4; ++i)
        mReturn[i] = Matrix(n, n, data[i]);
        
    return mReturn;
}


void Matrix::addPadding() {
    ++_Height;
    ++_Width;
    padded = false;
}


void Matrix::removePadding() {
    --_Width;
    --_Height;
    padded = true;
}


//
//  accessors and mutators
//
int		Matrix::getWidth()						{ return _Width;      }
int		Matrix::getHeight()						{ return _Height;     }
